//+------------------------------------------------------------------+
//|                                         Heiken Ashi Smoothed.mq4 |
//|                                                                  |
//|                                                      mod by Raff |
//+------------------------------------------------------------------+

//Optimized by Mark1213 1/19/2012

#property copyright "Copyright  2006, Forex-TSD.com"
#property link      "http://www.forex-tsd.com/"
//----
#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1 Red
#property indicator_color2 Lime
#property indicator_color3 Red
#property indicator_color4 Lime
//---- parameters
extern int MaMethod = 2;
extern int MaPeriod = 6;
extern int MaMethod2 = 3;
extern int MaPeriod2 = 2;
//---- buffers
double ExtMapBuffer1[];
double ExtMapBuffer2[];
double ExtMapBuffer3[];
double ExtMapBuffer4[];
double ExtMapBuffer5[];
double ExtMapBuffer6[];
double ExtMapBuffer7[];
double ExtMapBuffer8[];
//----

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//|------------------------------------------------------------------|
int init()
{
    int draw_begin = MaPeriod*MaPeriod2;
    
    IndicatorBuffers(8);
    
    SetIndexStyle(0,DRAW_HISTOGRAM, 0, 1, Red);
    SetIndexBuffer(0, ExtMapBuffer1);
    SetIndexDrawBegin(0,draw_begin);
   
    SetIndexStyle(1,DRAW_HISTOGRAM, 0, 1, Lime);
    SetIndexBuffer(1, ExtMapBuffer2);
    SetIndexDrawBegin(1,draw_begin);
   
    SetIndexStyle(2,DRAW_HISTOGRAM, 0, 3, Red);
    SetIndexBuffer(2, ExtMapBuffer3);
    SetIndexLabel(2,"OpenAvg");
    SetIndexDrawBegin(2,draw_begin);
   
    SetIndexStyle(3,DRAW_HISTOGRAM, 0, 3, Lime);
    SetIndexBuffer(3, ExtMapBuffer4);
    SetIndexLabel(3,"CloseAvg");
    SetIndexDrawBegin(3,draw_begin);
   
    SetIndexBuffer(4,ExtMapBuffer5);
    SetIndexBuffer(5,ExtMapBuffer6);
    SetIndexBuffer(6,ExtMapBuffer7);
    SetIndexBuffer(7,ExtMapBuffer8);

    return(0);
}

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
{
    double maOpen, maClose, maLow, maHigh;
    double haOpen, haHigh, haLow, haClose;
    
    if(Bars <= MaPeriod * MaPeriod2) return(0);
    
    int counted_bars = IndicatorCounted();
    if (counted_bars<0) return(-1);
    if (counted_bars>0) counted_bars--;
    int limit = Bars - counted_bars;
   
    for(int pos = limit; pos >= 0; pos--)
    {
        maOpen=iMA(NULL,0,MaPeriod,0,MaMethod,MODE_OPEN,pos);
        maClose=iMA(NULL,0,MaPeriod,0,MaMethod,MODE_CLOSE,pos);
        maLow=iMA(NULL,0,MaPeriod,0,MaMethod,MODE_LOW,pos);
        maHigh=iMA(NULL,0,MaPeriod,0,MaMethod,MODE_HIGH,pos);

        haOpen=(ExtMapBuffer5[pos+1]+ExtMapBuffer6[pos+1])/2;
        haClose=(maOpen+maHigh+maLow+maClose)/4;
        haHigh=MathMax(maHigh, MathMax(haOpen, haClose));
        haLow=MathMin(maLow, MathMin(haOpen, haClose));
      
        if (haOpen<haClose)
        {
            ExtMapBuffer7[pos]=haLow;
            ExtMapBuffer8[pos]=haHigh;
        }
        else
        {
            ExtMapBuffer7[pos]=haHigh;
            ExtMapBuffer8[pos]=haLow;
        }
        ExtMapBuffer5[pos]=haOpen;
        ExtMapBuffer6[pos]=haClose;
    }
   
    for(int i=0; i <= limit; i++)
    {
        ExtMapBuffer1[i]=iMAOnArray(ExtMapBuffer7,Bars,MaPeriod2,0,MaMethod2,i);
        ExtMapBuffer2[i]=iMAOnArray(ExtMapBuffer8,Bars,MaPeriod2,0,MaMethod2,i);
        ExtMapBuffer3[i]=iMAOnArray(ExtMapBuffer5,Bars,MaPeriod2,0,MaMethod2,i);
        ExtMapBuffer4[i]=iMAOnArray(ExtMapBuffer6,Bars,MaPeriod2,0,MaMethod2,i);
    }

    return(0);
}
//+------------------------------------------------------------------+